/*
 * API documentation
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0.0-20181108155220-20181108155343
 * Contact: api.move@axa-assistance.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.insurance.bn.starter.model;

import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import org.threeten.bp.LocalDate;

import java.util.Objects;

/**
 * Identity of the driver.
 */
@ApiModel(description = "Identity of the driver.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2018-12-19T23:23:06.995+01:00")
public class Driver {
  @SerializedName("first_name")
  private String firstName = null;

  @SerializedName("last_name")
  private String lastName = null;

  @SerializedName("birth_date")
  private LocalDate birthDate = null;

  @SerializedName("gender")
  private String gender = null;

  @SerializedName("nationalities")
  private Model61 nationalities = null;

  @SerializedName("license_number")
  private String licenseNumber = null;

  @SerializedName("license_issued_country")
  private String licenseIssuedCountry = null;

  public Driver firstName(String firstName) {
    this.firstName = firstName;
    return this;
  }

   /**
   * First name.
   * @return firstName
  **/
  @ApiModelProperty(example = "John", value = "First name.")
  public String getFirstName() {
    return firstName;
  }

  public void setFirstName(String firstName) {
    this.firstName = firstName;
  }

  public Driver lastName(String lastName) {
    this.lastName = lastName;
    return this;
  }

   /**
   * Last name.
   * @return lastName
  **/
  @ApiModelProperty(example = "Doe", required = true, value = "Last name.")
  public String getLastName() {
    return lastName;
  }

  public void setLastName(String lastName) {
    this.lastName = lastName;
  }

  public Driver birthDate(LocalDate birthDate) {
    this.birthDate = birthDate;
    return this;
  }

   /**
   * Birth date - ISO 8601 format (YYYY-MM-DD).
   * @return birthDate
  **/
  @ApiModelProperty(value = "Birth date - ISO 8601 format (YYYY-MM-DD).")
  public LocalDate getBirthDate() {
    return birthDate;
  }

  public void setBirthDate(LocalDate birthDate) {
    this.birthDate = birthDate;
  }

  public Driver gender(String gender) {
    this.gender = gender;
    return this;
  }

   /**
   * Gender (Male or Female). Expected values (ML, FM).
   * @return gender
  **/
  @ApiModelProperty(example = "ML", value = "Gender (Male or Female). Expected values (ML, FM).")
  public String getGender() {
    return gender;
  }

  public void setGender(String gender) {
    this.gender = gender;
  }

  public Driver nationalities(Model61 nationalities) {
    this.nationalities = nationalities;
    return this;
  }

   /**
   * Get nationalities
   * @return nationalities
  **/
  @ApiModelProperty(value = "")
  public Model61 getNationalities() {
    return nationalities;
  }

  public void setNationalities(Model61 nationalities) {
    this.nationalities = nationalities;
  }

  public Driver licenseNumber(String licenseNumber) {
    this.licenseNumber = licenseNumber;
    return this;
  }

   /**
   * License number of the driver.
   * @return licenseNumber
  **/
  @ApiModelProperty(value = "License number of the driver.")
  public String getLicenseNumber() {
    return licenseNumber;
  }

  public void setLicenseNumber(String licenseNumber) {
    this.licenseNumber = licenseNumber;
  }

  public Driver licenseIssuedCountry(String licenseIssuedCountry) {
    this.licenseIssuedCountry = licenseIssuedCountry;
    return this;
  }

   /**
   * Country where the card has been issued. Country ISO-3166-1 alpha-2 format (2 letter codes).
   * @return licenseIssuedCountry
  **/
  @ApiModelProperty(value = "Country where the card has been issued. Country ISO-3166-1 alpha-2 format (2 letter codes).")
  public String getLicenseIssuedCountry() {
    return licenseIssuedCountry;
  }

  public void setLicenseIssuedCountry(String licenseIssuedCountry) {
    this.licenseIssuedCountry = licenseIssuedCountry;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Driver driver = (Driver) o;
    return Objects.equals(this.firstName, driver.firstName) &&
        Objects.equals(this.lastName, driver.lastName) &&
        Objects.equals(this.birthDate, driver.birthDate) &&
        Objects.equals(this.gender, driver.gender) &&
        Objects.equals(this.nationalities, driver.nationalities) &&
        Objects.equals(this.licenseNumber, driver.licenseNumber) &&
        Objects.equals(this.licenseIssuedCountry, driver.licenseIssuedCountry);
  }

  @Override
  public int hashCode() {
    return Objects.hash(firstName, lastName, birthDate, gender, nationalities, licenseNumber, licenseIssuedCountry);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Driver {\n");
    
    sb.append("    firstName: ").append(toIndentedString(firstName)).append("\n");
    sb.append("    lastName: ").append(toIndentedString(lastName)).append("\n");
    sb.append("    birthDate: ").append(toIndentedString(birthDate)).append("\n");
    sb.append("    gender: ").append(toIndentedString(gender)).append("\n");
    sb.append("    nationalities: ").append(toIndentedString(nationalities)).append("\n");
    sb.append("    licenseNumber: ").append(toIndentedString(licenseNumber)).append("\n");
    sb.append("    licenseIssuedCountry: ").append(toIndentedString(licenseIssuedCountry)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

